package at.ac.uibk.gitsearch.service.dto;

import java.io.Serializable;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class ReviewRatingDTO {

    String comment;
    String status;

    public ReviewRatingDTO() {}

    public ReviewRatingDTO(String comment, String status) {
        this.comment = comment;
        this.status = status;
    }

    public String getComment() {
        return comment;
    }

    public void setComment(String comment) {
        this.comment = comment;
    }

    public String getStatus() {
        return status;
    }

    public void setStatus(String status) {
        this.status = status;
    }

    /**
     * holds a count of the review stati as Map.
     *
     * @author Michael Breu
     *
     */
    public static class ReviewStatisticsDTO implements Serializable {

        private static final Logger LOGGER = LoggerFactory.getLogger(ReviewStatisticsDTO.class);
        /**
         * serialVersionUID
         */
        private static final long serialVersionUID = 7584249169269270589L;

        /*
         * Review In Progress
         * Review improved
         * Review completed
         */
        private int reviewInProgress = 0;
        private int reviewImproved = 0;
        private int reviewCompleted = 0;
        private int unknownStats = 0;

        public int getReviewInProgress() {
            return reviewInProgress;
        }

        public void setReviewInProgress(int reviewInProgress) {
            this.reviewInProgress = reviewInProgress;
        }

        public int getReviewImproved() {
            return reviewImproved;
        }

        public void setReviewImproved(int reviewImproved) {
            this.reviewImproved = reviewImproved;
        }

        public int getReviewCompleted() {
            return reviewCompleted;
        }

        public void setReviewCompleted(int reviewCompleted) {
            this.reviewCompleted = reviewCompleted;
        }

        public int getUnknownStats() {
            return unknownStats;
        }

        public void setUnknownStats(int unknownStats) {
            this.unknownStats = unknownStats;
        }

        public void put(String status, int count) {
            switch (status) {
                case "Review In Progress":
                    reviewInProgress = count;
                    break;
                case "Review improved":
                    reviewImproved = count;
                    break;
                case "Review completed":
                    reviewCompleted = count;
                    break;
                default:
                    LOGGER.error("status {} not yet supported!", status);
                    unknownStats += count;
                    break;
            }
        }
    }
}
